# Copyright 1999-2006 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

inherit eutils flag-o-matic toolchain-funcs

DESCRIPTION="Generic Package and Module Interface"
HOMEPAGE="http://www.libgpmi.org/"
SRC_URI="mirror://sourceforge/${PN}/${P}.tar.gz"

RESTRICT="nomirror"
LICENSE="LGPL-2"
SLOT="0"
KEYWORDS="x86 amd64"
IUSE="ruby tcl python perl lua"

RDEPEND=""
DEPEND="${RDEPEND}
	sys-apps/gawk
	app-shells/bash
	ruby? ( dev-lang/ruby )
	tcl? ( dev-lang/tcl )
	python? ( dev-lang/python )
	perl? ( dev-lang/perl )
	lua? ( dev-lang/lua )"

src_unpack() {
	unpack ${A}
}

src_compile() {
	local confopts="--prefix=/usr/local"
	confopts="${confopts} --target=${CHOST} --host=${CBUILD}"
	tc-is-cross-compiler && confopts="${confopts} --cross=yes" 

	# For PHP we need embed, which ebuild currently doesn't support
	confopts="${confopts} --with-php=0"
	# GHLI doesn't have an ebuild yet
	confopts="${confopts} --with-ghli=0"
	# Stutter doesn't have an ebuild yet
	confopts="${confopts} --with-stutter=0"

	use tcl && confopts="${confopts} --with-tcl=1"
	use tcl || confopts="${confopts} --with-tcl=0"

	use python && confopts="${confopts} --with-python=1"
	use python || confopts="${confopts} --with-python=0"

	use lua && confopts="${confopts} --with-lua=1"
	use lua || confopts="${confopts} --with-lua=0"

	use ruby && confopts="${confopts} --with-ruby=1"
	use ruby || confopts="${confopts} --with-ruby=0"

	use perl && confopts="${confopts} --with-perl=1"
	use perl || confopts="${confopts} --with-perl=0"

	#econf $confopts || die "econf failed"
	echo "./configure $confopts"
	./configure $confopts || die "configure failed"
	emake all || die "emake failed"
}

src_test() {
	tc-is-cross-compiler && return 0

	make test || die "make test failed"
}

src_install() {
	cd config
	./Install.sh -P ${D}/usr/local || die
	cd ..
	dodoc COPYING Changelog INSTALL Readme doc/Credits doc/LGPL-2
}

