#!/bin/sh

function ask() {
	echo -n "$1 [${!2}]: "
	read n
	if ! test -z "$n"
	then
		export $2=$n
	fi
}

if test -f svn-merge.conf
then
	. svn-merge.conf
	cp -f svn-merge.conf svn-merge.conf.old
else 
	echo 'trunk=-
	local=-	
	' > svn-merge.conf.old
fi

if test -f svn-merge.last
then
	last=`cat svn-merge.last`
else
	last=1
fi

ask "Remote trunk url (to sync with)" "trunk"
head=`svn -r HEAD:HEAD log $trunk | grep "^r[0-9][0-9]* |" | sed "s/|.*//;s/^r//"`
if test -z "$head"
then
	echo "$trunk can't be accessed. Exiting."
else
	echo " (ok, head revision of $trunk is $head)"
fi

ask "Path to local copy" "local" 
if ! test -d "$local/.svn"
then
	echo "$local is not a working copy. Exiting."
	exit
else
	echo " (ok, $local/.svb is a dir)"
fi

ask "Last revision merged" "last"
if test $last -gt $head
then
	echo "Error: we have only $head revisions. Exiting."
	exit
else
	echo " (ok)"
fi


echo $last > svn-merge.last

sed "s@^#Example on .*@@;s#^trunk=.*#trunk=$trunk#;s#^local=.*#local=$local#" < svn-merge.conf.old > svn-merge.conf
rm -f svn-merge.conf.old

echo "Configuraiton finished."
