/* The main gpmi include file. Include this in your app */
#include <gpmi/global.h>
#include <gpmi/libs.h>
#include <gpmi/libs-package.h>
#include <gpmi/libs-module.h>
#include <gpmi/keywords.h>
#include <gpmi/keyword_hash.h>
#include <gpmi/error.h>
#include <gpmi/events.h>
#include <gpmi/debug.h>
#include <gpmi/hash/hash.h>
#include <gpmi/packages.h>
#include <gpmi/threads.h>
#include <gpmi/paths.h>

/*	These set of macros determine which lib loading strategies to define.
		Default (no #define)		 		include both static and dynamic loading; -lgpmi
		#define GPMI_DYNAMIC_ONLY		only dynamic loading; -lgpmi-dynamic
		#define GPMI_STATIC_ONLY		only static loading; -lgpmi-static
*/

#ifdef GPMI_DYNAMIC_ONLY
#	ifdef GPMI_STATIC_ONLY
#		error "You can't define both GPMI_DYNAMIC_ONLY and GPMI_STATIC_ONLY"
#	endif
#	define gpmi_fake_static
#	define gpmi_no_static
#endif

#ifdef GPMI_STATIC_ONLY
#	define gpmi_fake_dynamic
#	define gpmi_no_dynamic
#endif
