#!/bin/bash

# We define these empty funcitons here so if the user doesn't redefine them,
# these will be called: error is catched.

function RunTick() {
	true
}

function RunData() {
	true
}

# GPMI wrappers
function GPMI()
{
	local gpmi_tmp

	echo "###GPMI### $*"
	while(/bin/true)
	do
		read gpmi_tmp
		case $gpmi_tmp
		in
			Result*) result=`echo $gpmi_tmp | sed "s/Result[ ]*//"`; cli_dprint "RES: $result"; return ;;
			*) echo "[scr] push in: $gpmi_tmp"; bpush gpmi_in_buff "$gpmi_tmp" ; gpmi_parse ;;
		esac
	done

}

function cli_dprint()
{
	echo "###GPMI### cli_dprint $*"
}

function cli_print()
{
	echo "###GPMI### cli_print $*"
}

# functions for buffered read
function bread()
{
	local first remain tmp
	if test -z "${!1}"
	then
		#buffer is empty, read from stdin
		read tmp
		export $2="$tmp"
	else
		# return the first line from the buffer
		first=`echo "${!1}" | head -n 1`
		remain=`echo "${!1}" | awk '{if (NR != 1) print $0}'`
		export $1="$remain"
		export $2="$first"
	fi		
}

function bpush()
{
	local name
	name=$1
	shift 1
	if test -z "${!name}"
	then
		export $name="$*"	
	else
		export $name="${!name}
$*"
	fi
}

function gpmi_parse() {
	cli_dprint "[waiting]"
	bread gpmi_in_buff gpmi_in
	cli_dprint "[IN] $gpmi_in"

	gpmi_arg=${gpmi_in#*[ 	]}
	gpmi_cmd=${gpmi_in%%[ 	]*}

	if test -z "$gpmi_cmd"
	then
		return
	fi

	case "$gpmi_cmd" in
		Event)	$gpmi_arg ;;
		RunTick) RunTick $gpmi_arg ;;
		RunData) RunData $gpmi_arg ;;
		Rehash) exec $gpmi_arg ;;
		Result) ;; #eat up the results out of sync; this is probably a bad idea, but falling out of sync would mostly kill the whole stuff anyway
		Quit) echo "###GPMI_FIN###"; exit ;;
		Nop) ;;
		Result) bpush gpmi_res_buff $* ;;
		*) echo "Error: unknown input from GPMI: \"$gpmi_in\""
	esac
	echo "###GPMI_FIN###"
}
