#ifndef SCRIPT_MODULE_PERL_H
#define SCRIPT_MODULE_PERL_H

#include <EXTERN.h>
#include <perl.h>
#include "packages/gpmi_scripts.h"

typedef struct Perl_ClientData {
	PerlInterpreter *interp;
	int started;
	char **commands;
	int commands_size;
} Perl_ClientData;

int  Perl_Initialize(void **client_data);
void Perl_Destroy(void **client_data);
void Perl_RegisterCommand(void *client_data, const char *name);
int  Perl_LoadScript(void *client_data, const char *filename);
char *Perl_GetExtension();
int  Perl_Rehash(void *client_data);
void Perl_RunFunction(void *client_data, const char *function, int argc, const char **argv);

#endif /* SCRIPT_MODULE_PERL_H */
