#ifndef SCRIPT_MODULE_TCL_H
#define SCRIPT_MODULE_TCL_H

#include <tcl.h>
#include "packages/gpmi_scripts.h"

typedef struct TCL_ClientData {
	Tcl_Interp *interp;
	char *script_name;
} TCL_ClientData;

int  TCL_Initialize(void **client_data);
void TCL_Destroy(void **client_data);
void TCL_RegisterCommand(void *client_data, const char *name);
int  TCL_LoadScript(void *client_data, const char *filename);
char *TCL_GetExtension();
int  TCL_Rehash(void *client_data);
void TCL_RunFunction(void *client_data, const char *function, int argc, const char **argv);

// tcl.c
void TCL_ReportTclError(TCL_ClientData *TCL_MyData);

#endif /* SCRIPT_MODULE_TCL_H */
