#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "hash.h"

/* I won't comment too often in this code: this package is really just
   a wrapper around hash.c, see comments there.
*/

void *gpmi_hash_create(int size)
{
	return hash_create(size, NULL);
}

void gpmi_hash_store(void *table, char *key, char *data)
{
	char *dt;

	/* Save data */
	dt = strdup(data);

	/* Store the pointer */
	hash_store(table, key, dt);
}

char *gpmi_hash_find(void *table, const char *key)
{
	return strdup(hash_find(table, key));
}



int gpmi_hash_stat_recno(void *table)
{
	int res;

	hash_stat(table, &res, NULL, NULL, NULL, NULL);
	return res;
}

int gpmi_hash_stat_empty_node(void *table)
{
	int res;

	hash_stat(table, NULL, &res, NULL, NULL, NULL);
	return res;
}


double gpmi_hash_stat_avg_node(void *table)
{
	float res;

	hash_stat(table, NULL, NULL, &res, NULL, NULL);
	return res;
}

int gpmi_hash_stat_max_node(void *table)
{
	int res;

	hash_stat(table, NULL, NULL, NULL, &res, NULL);
	return res;
}


int gpmi_hash_stat_mem(void *table)
{
	int res;

	hash_stat(table, NULL, NULL, NULL, NULL, &res);
	return res;
}

void *gpmi_hash_rehash(void *table, int new_size)
{
	return hash_rehash(table, new_size, NULL);
}

