# This is an example how to use ruby with gpmi. This script is also part of
# the regression test

def RunData(data)
	print("main:RunData #{data} == 0x1234\n")
end

def ev_cycle(timer_data)
	ttl = TimerInfo(timer_data, "TTL");
	freq = TimerInfo(timer_data, "freq");
	user_data = TimerInfo(timer_data, "user_data");

	print("main:ev_cycle ( #{$global_ttl} == #{ttl} )  ( #{$global_freq} == #{freq} ) ( #{user_data} == data1 ) (runs 4 times)\n")

	$global_ttl -= 1
end

def ev_every_second(timer_data)
	ttl = TimerInfo(timer_data, "TTL");
	freq = TimerInfo(timer_data, "freq");
	user_data = TimerInfo(timer_data, "user_data");

	print("main:ev_every_second ( #{$global_ttl} == #{ttl} )  ( #{$global_freq} == #{freq} ) ( #{user_data} == data2 ) (runs 3 times)\n")

	$global_ttl -= 1
end

def ev_nothing(id, year, param)
	print("main:ev_nothing: year: ( #{$global_year} == #{year} ) param: ( #{$global_param} == #{param} )\n")
end

print("main:Running init part.\n")

# Check timers
$global_ttl = 4
$global_freq = 0
AddTimer(4, 0, "ev_cycle", "data1")
$global_ttl = 3
$global_freq = 2
AddTimer(3, 2, "ev_every_second", "data2")

# Check package loading
PkgLoad("example", 0)
print("main:main1 #{Example_int(10)} == 1244 when works\n")

# Check events
$global_year = 2005
$global_param = 155
Bind("Example_nothing", "ev_nothing")
Example_do_nothing(155)

# Check FakeEvent
$global_year = 3000
$global_param = 20
FakeEvent("Example_nothing", "3000 20")

print("main:main2 Finished init part.\n")
