#ifndef WRAPGEN_PARSER_H
#define WRAPGEN_PARSER_H

extern char *type_names[];							//! names of valid types

typedef enum types {
	type_keyword = 0,
	type_int     = 1,
	type_string  = 2,
	type_double  = 3,
	type_void    = 4,
	type_uint		 = 5,
	type_ptr     = 6,
	type_uchar   = 7,
	type_char    = 8,
} types ;

#define number_of_types 9

typedef enum type_flags {
	flag_dynamic  = 1,
	flag_multiple = 2,
	flag_const    = 4,
	flag_direct		= 8,
} type_flags;

typedef enum file_cmds {
	close_files,
	open_files,
} file_cmds;

void split(char *string, char *first, char *second);	//! Split a line in two words
int FindType(char *name); 														//! Finds a type by name
int GetTypeFlags(char *type, int line);								//! resolve type prefixes
void GenWrapper(FILE *input, void *generator, void *newproc, void *gotparam, void *fileoperations, const char *section);
//!< parse a list file and callback the wrapper generator functions

#endif /* WRAPGEN_PARSER_H */

